-- knjiznica, ki jo uporabljamo
library IEEE;
use IEEE.STD_LOGIC_1164.all;

-- entiteta
entity mealy is
	port (clk, rst, X: in std_logic; 
		Z: out std_logic;
		Y: out std_logic_vector(1 downto 0)); 	
end mealy;

architecture behavioral of mealy is
	signal Q1, Q0: std_logic;
begin
	process (clk)
	begin
		if (rising_edge(clk)) then
			Q1 <= 	(not rst and (not X and		Q1 and not Q0)) or
					(not rst and (	 X and	not Q1 and     Q0));

			Q0 <= 	(not rst and (not X and not Q1 and     Q0)) or
		   			(not rst and (    X and not Q1 and not Q0));
		end if;
	end process;

	Z <= 	not rst and X and ( Q1 and not Q0); 
	Y(1) <= Q1;
	Y(0) <= Q0;

end architecture;
