-- knjiznica, ki jo uporabljamo
library IEEE;
use IEEE.STD_LOGIC_1164.all;

-- entiteta
entity mealy is
	port (clk, rst, X: in std_logic; 
		Z: out std_logic);
end mealy;


architecture behavioral of mealy is
	type states is (Y0, Y1, Y2); 
	signal currSt, nextSt: states; -- pomozni signali 
	signal nextZ: std_logic; -- izhodna crka
begin
	process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				currSt <= Y0;
				Z <= '0';
			else
				currSt <= nextSt;
				Z <= nextZ;
			end if;
		end if;
	end process;

	process (currSt, x)
	begin
		case currSt is
			when Y0 =>
				if (X = '0') then nextSt <= Y0;
					     	  nextZ  <= '0';
					      else nextSt <= Y1;
						   nextZ  <= '0';
				end if;
			when Y1 =>
				if (X = '0') then nextSt <= Y1;
						  nextZ  <= '0';
					      else nextSt <= Y2;
						   nextZ  <= '0';
				end if;
			when Y2 =>
				if (X = '0') then nextSt <= Y2;
					     	  nextZ  <= '0';
					      else nextSt <= Y0;
						   nextZ  <= '1';
				end if;
			end case;
		end process;
end architecture;

